﻿using UnityEngine;
using System.Collections;

//Controlls player inputs
public class PlayerInput : MonoBehaviour {
	//The movementController script
	private MovementController moveCont;

	//All default key commands

	public KeyCode moveLeftKey = KeyCode.LeftArrow;
	public KeyCode moveRightKey = KeyCode.RightArrow;
	public KeyCode jumpKey = KeyCode.UpArrow;
	public KeyCode boostKey = KeyCode.RightShift;
	public KeyCode punchKey = KeyCode.RightControl;

	// Use this for initialization
	void Start () {
		moveCont = (MovementController)GetComponent(typeof(MovementController));
	}
	
	// Update is called once per fixed frame
	void Update () {
		Vector3 moveDir = new Vector3();
		if(Input.GetKey(moveLeftKey)){
			moveDir += -transform.right;
		}
		if(Input.GetKey(moveRightKey)){
			moveDir += transform.right;
		}

		//Player is trying to move.  Move them
		if (moveDir.magnitude > 0){moveCont.move(moveDir);}

		if(Input.GetKeyDown(jumpKey)){
			moveCont.jump();
		}

		if(Input.GetKeyDown(boostKey)){
			moveCont.boost();
		}

		if(Input.GetKeyDown(punchKey)){
			moveCont.punch();
		}


	}
}
