﻿using UnityEngine;
using System.Collections;

public class PlayerSpawner : MonoBehaviour {

	public int numPlayers = 8;	//Number of active players

	public GameObject playerObject;

	#region player data
	//Player 1 Details
	public Color playerColorP0;
	public KeyCode moveLeftKeyP0 = KeyCode.A;
	public KeyCode moveRightKeyP0 = KeyCode.D;
	public KeyCode jumpKeyP0 = KeyCode.W;
	public KeyCode boostKeyP0 = KeyCode.Q;
	public KeyCode punchKeyP0 = KeyCode.E;

	//Player 2 Details
	public Color playerColorP1;
	public KeyCode moveLeftKeyP1 = KeyCode.LeftArrow;
	public KeyCode moveRightKeyP1 = KeyCode.RightArrow;
	public KeyCode jumpKeyP1 = KeyCode.UpArrow;
	public KeyCode boostKeyP1 = KeyCode.Period;
	public KeyCode punchKeyP1 = KeyCode.Slash;

	//Player 3 Details
	public Color playerColorP2;
	public KeyCode moveLeftKeyP2 = KeyCode.Keypad4;
	public KeyCode moveRightKeyP2 = KeyCode.Keypad3;
	public KeyCode jumpKeyP2 = KeyCode.Keypad2;
	public KeyCode boostKeyP2 = KeyCode.Keypad0;
	public KeyCode punchKeyP2 = KeyCode.KeypadPeriod;

	//Player 4 Details
	public Color playerColorP3;
	public KeyCode moveLeftKeyP3 = KeyCode.F;
	public KeyCode moveRightKeyP3 = KeyCode.H;
	public KeyCode jumpKeyP3 = KeyCode.T;
	public KeyCode boostKeyP3 = KeyCode.R;
	public KeyCode punchKeyP3 = KeyCode.Y;

	//Player 5 Details
	public Color playerColorP4;
	public KeyCode moveLeftKeyP4 = KeyCode.Keypad4;
	public KeyCode moveRightKeyP4 = KeyCode.Keypad6;
	public KeyCode jumpKeyP4 = KeyCode.Keypad8;
	public KeyCode boostKeyP4 = KeyCode.Keypad7;
	public KeyCode punchKeyP4 = KeyCode.Keypad9;

	//Player 6 Details
	public Color playerColorP5;
	public KeyCode moveLeftKeyP5 = KeyCode.J;
	public KeyCode moveRightKeyP5 = KeyCode.L;
	public KeyCode jumpKeyP5 = KeyCode.I;
	public KeyCode boostKeyP5 = KeyCode.U;
	public KeyCode punchKeyP5 = KeyCode.O;

	//Player 7 Details
	public Color playerColorP6;
	public KeyCode moveLeftKeyP6 = KeyCode.Alpha2;
	public KeyCode moveRightKeyP6 = KeyCode.Alpha4;
	public KeyCode jumpKeyP6 = KeyCode.Alpha3;
	public KeyCode boostKeyP6 = KeyCode.Alpha1;
	public KeyCode punchKeyP6 = KeyCode.Alpha5;

	//Player 8 Details
	public Color playerColorP7;
	public KeyCode moveLeftKeyP7 = KeyCode.Alpha7;
	public KeyCode moveRightKeyP7 = KeyCode.Alpha9;
	public KeyCode jumpKeyP7 = KeyCode.Alpha8;
	public KeyCode boostKeyP7 = KeyCode.Alpha6;
	public KeyCode punchKeyP7 = KeyCode.Alpha0;
	#endregion

	// Use this for initialization
	void Start () {
		GameObject[] spawns;
		spawns = GameObject.FindGameObjectsWithTag("Spawnpoint");
		if (spawns.Length > 0){
			SpawnPlayers ();
		}
	}
	
	// Update is called once per frame
	void Update () {
	
	}

	void OnLevelWasLoaded(int level){
		GameObject[] spawns;
		spawns = GameObject.FindGameObjectsWithTag("Spawnpoint");
		if (spawns.Length > 0){
			SpawnPlayers ();
		}
	}

	public void SpawnPlayers(){
		GameObject[] spawns;
		GameObject tempPlayer;
		PlayerInput tempInput;
		MovementController tempMoveCont;
		for (int i=0;i<numPlayers;i++){
			spawns = GameObject.FindGameObjectsWithTag("Spawnpoint");
			int randSpawn = Random.Range(0,spawns.Length);
			tempPlayer = (GameObject)Instantiate(playerObject,spawns[randSpawn].transform.position,Quaternion.identity);
			
			tempInput = (PlayerInput)tempPlayer.GetComponent(typeof(PlayerInput));
			tempMoveCont = (MovementController)tempPlayer.GetComponent(typeof(MovementController));
			//Busy busy busy
			if (i == 0){
				tempInput.moveLeftKey = moveLeftKeyP0;
				tempInput.moveRightKey = moveRightKeyP0;
				tempInput.jumpKey = jumpKeyP0;
				tempInput.boostKey = boostKeyP0;
				tempInput.punchKey = punchKeyP0;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP0);
			}else if (i == 1){
				tempInput.moveLeftKey = moveLeftKeyP1;
				tempInput.moveRightKey = moveRightKeyP1;
				tempInput.jumpKey = jumpKeyP1;
				tempInput.boostKey = boostKeyP1;
				tempInput.punchKey = punchKeyP1;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP1);
			}else if (i == 2){
				tempInput.moveLeftKey = moveLeftKeyP2;
				tempInput.moveRightKey = moveRightKeyP2;
				tempInput.jumpKey = jumpKeyP2;
				tempInput.boostKey = boostKeyP2;
				tempInput.punchKey = punchKeyP2;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP2);
			}else if (i == 3){
				tempInput.moveLeftKey = moveLeftKeyP3;
				tempInput.moveRightKey = moveRightKeyP3;
				tempInput.jumpKey = jumpKeyP3;
				tempInput.boostKey = boostKeyP3;
				tempInput.punchKey = punchKeyP3;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP3);
			}else if (i == 4){
				tempInput.moveLeftKey = moveLeftKeyP4;
				tempInput.moveRightKey = moveRightKeyP4;
				tempInput.jumpKey = jumpKeyP4;
				tempInput.boostKey = boostKeyP4;
				tempInput.punchKey = punchKeyP4;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP4);
			}else if (i == 5){
				tempInput.moveLeftKey = moveLeftKeyP5;
				tempInput.moveRightKey = moveRightKeyP5;
				tempInput.jumpKey = jumpKeyP5;
				tempInput.boostKey = boostKeyP5;
				tempInput.punchKey = punchKeyP5;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP5);
			}else if (i == 6){
				tempInput.moveLeftKey = moveLeftKeyP6;
				tempInput.moveRightKey = moveRightKeyP6;
				tempInput.jumpKey = jumpKeyP6;
				tempInput.boostKey = boostKeyP6;
				tempInput.punchKey = punchKeyP6;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP6);
			}else if (i == 7){
				tempInput.moveLeftKey = moveLeftKeyP7;
				tempInput.moveRightKey = moveRightKeyP7;
				tempInput.jumpKey = jumpKeyP7;
				tempInput.boostKey = boostKeyP7;
				tempInput.punchKey = punchKeyP7;
				tempMoveCont.playerNum = i;
				tempMoveCont.setColor (playerColorP7);
			}
			
			spawns[randSpawn].tag = "NotSpawnpoint";
			Destroy(spawns[randSpawn].gameObject);
		}
	}
}
