﻿using UnityEngine;
using System.Collections;

public class Timer : MonoBehaviour {

	public float timeLeft = 60.0f;
	private float timeReset;

	public AudioClip loadClip;

	public int fontSize = 10;
	public FontStyle fontStyle;
	public Color fontColor;

	public GameManager gameManager;

	private GUIStyle guiStyle;

	// Use this for initialization
	void Start () {
		timeReset = timeLeft;
		guiStyle = new GUIStyle();

		guiStyle.fontSize=fontSize;
		guiStyle.fontStyle=fontStyle;
		guiStyle.normal.textColor = fontColor;
	}
	
	// Update is called once per frame
	void Update () {
		timeLeft -= Time.deltaTime;
		if (timeLeft<=0.0f){gameManager.LoadNextLevel();}
	}

	void OnLevelWasLoaded(int level) {
		AudioSource.PlayClipAtPoint(loadClip,transform.position,0.8f);
		timeLeft = timeReset;
	}
	
	void OnGUI (){
		if (timeLeft<=10.0f){
			GUI.Label(new Rect(Screen.width * 0.5f - 50f, Screen.height * 0.33f - 10f, 100f, 20f), (""+Mathf.Ceil(timeLeft)), guiStyle);
		}
	}


}
